#include <bits\stdc++.h>
using namespace std;

int n, q, d[200000], p[200000], h[200000];
bool dz = true, pz = true;

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int i, j;
	cin >> n >> q;
	for(i = 0; i < n; i++){
		cin >> d[i] >> p[i];
		if(dz && d[i] != 0)dz = false;
		if(pz && p[i] != 0)pz = false;
	}
	for(i = 0; i < q; i++){
		cin >> h[i];
	}
	
	if(pz){
		for(j = 0; j < q; j++){
			for(i = 0;i<n && h[j]> 0; i++){
				h[j]-=d[i];
			}
			if(i < n)cout << i;
			else cout << -1;
		}
		return 0;
	}

	if(dz){
		long long acum;
		for(j = 0; j < q; j++){
			acum = 0;
			for(i = 0;i<n && h[j]> 0; i++){
				acum+= p[i];
				h[j]-=acum;
			}
			if(i < n)cout << i;
			else cout << -1;
		}
		return 0;
	}
	
	return 0;
}